<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/models/about.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// get changelog
require_once( JPATH_COMPONENT_ADMINISTRATOR.DS.'CHANGELOG.php' );

/**
 * About Model
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeModelAbout extends JModel
{
	/**
	 * version
	 * @var string
	 */
	var $_version;
	
	/**
	 * contructor
	 */
	function __construct()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$this->_version = $_JMLConfig->version->getFullVersion();
		parent::__construct();
  }
	/**
	 * Gets the installed version
	 * @return string version number
	 */
	function getVersion()
	{
		return $this->_version;
	}
	/**
	 * Gets the latest version
	 * @return string latest version number
	 */
	function getCurrentVersion()
	{
		// fetch latest version from http://jeffchannell.com/jmylife-version.php
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$version = JmylifeVersionHelper::getInstance();
		return $version->getCurrentVersion();
	}
	/**
	 * Compares installed version vs latest
	 * @return string   color-coded HTML
	 */
	function getComparedVersions()
	{
		$installed = $this->getVersion();
		$current   = $this->getCurrentVersion();
		$color = '#000';
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$version = JmylifeVersionHelper::getInstance();
		switch( $version->getComparedVersions() )
		{
			// needs upgrading
			case -1:
				$color = '#f00';
				break;
			// up to date
			case 0:
				$color = '#090';
				break;
			// prerelease
			case 1:
				$color = '#009';
				break;
		}
		return '<strong>'.JText::_('COM_JMYLIFE_ABOUT_VERSION').'</strong> : <span style="color:'.$color.';">'.$installed.'</span><br /><strong>'.JText::_('COM_JMYLIFE_ABOUT_LATEST').'</strong> : '.$current;
	}
}
